diff --git a/modules/Makefile b/modules/Makefile
index 843a136..a0f893c 100644
--- a/modules/Makefile
+++ b/modules/Makefile
@@ -1,7 +1,7 @@
 ################################################################################
 # AMiRo-OS is an operating system designed for the Autonomous Mini Robot       #
 # (AMiRo) platform.                                                            #
-# Copyright (C) 2016..2018  Thomas Schöpping et al.                            #
+# Copyright (C) 2016..2019  Thomas Schöpping et al.                            #
 #                                                                              #
 # This program is free software: you can redistribute it and/or modify         #
 # it under the terms of the GNU General Public License as published by         #
diff --git a/modules/PowerManagement_1-1/Makefile b/modules/PowerManagement_1-1/Makefile
index 30ed50a..cb3ee38 100644
--- a/modules/PowerManagement_1-1/Makefile
+++ b/modules/PowerManagement_1-1/Makefile
@@ -1,7 +1,7 @@
 ################################################################################
 # AMiRo-OS is an operating system designed for the Autonomous Mini Robot       #
 # (AMiRo) platform.                                                            #
-# Copyright (C) 2016..2018  Thomas Schöpping et al.                            #
+# Copyright (C) 2016..2019  Thomas Schöpping et al.                            #
 #                                                                              #
 # This program is free software: you can redistribute it and/or modify         #
 # it under the terms of the GNU General Public License as published by         #
@@ -119,12 +119,13 @@ PROJECT := $(patsubst $(abspath $(dir $(abspath $(lastword $(MAKEFILE_LIST))))..
 include ../../kernel/kernel.mk
 CHIBIOS := $(AMIROOS_KERNEL)
 AMIROOS = ../..
+# Licensing files
+include $(CHIBIOS)/os/license/license.mk
 # Startup files
 include $(CHIBIOS)/os/common/startup/ARMCMx/compilers/GCC/mk/startup_stm32f4xx.mk
 # HAL-OSAL files
 include $(CHIBIOS)/os/hal/hal.mk
 include $(CHIBIOS)/os/hal/ports/STM32/STM32F4xx/platform.mk
-include ./board.mk
 include $(CHIBIOS)/os/hal/osal/rt/osal.mk
 # RTOS files
 include $(CHIBIOS)/os/rt/rt.mk
@@ -132,6 +133,7 @@ include $(CHIBIOS)/os/common/ports/ARMCMx/compilers/GCC/mk/port_v7m.mk
 # Other files (optional).
 include $(CHIBIOS)/test/lib/test.mk
 include $(CHIBIOS)/test/rt/rt_test.mk
+include $(CHIBIOS)/test/oslib/oslib_test.mk
 # AMiRo-BLT files
 include ../../bootloader/bootloader.mk
 # AMiRo-LLD files
@@ -142,17 +144,17 @@ include $(AMIROOS)/core/core.mk
 include $(AMIROOS)/unittests/unittests.mk
 
 # Define linker script file here
-LDSCRIPT= $(BOARDLD)/STM32F405xG.ld
+LDSCRIPT= STM32F405xG.ld
 
 # C sources that can be compiled in ARM or THUMB mode depending on the global
 # setting.
-CSRC = $(STARTUPSRC) \
+CSRC = $(LICSRC) \
+       $(STARTUPSRC) \
        $(KERNSRC) \
        $(PORTSRC) \
        $(OSALSRC) \
        $(HALSRC) \
        $(PLATFORMSRC) \
-       $(BOARDSRC) \
        $(MODULESCSRC) \
        $(TESTSRC) \
        $(PERIPHERYLLDCSRC) \
@@ -161,12 +163,14 @@ CSRC = $(STARTUPSRC) \
        $(CHIBIOS)/os/various/evtimer.c \
        $(CHIBIOS)/os/various/syscalls.c \
        $(CHIBIOS)/os/hal/lib/streams/chprintf.c \
+       board.c \
        module.c \
        $(APPSCSRC)
 
 # C++ sources that can be compiled in ARM or THUMB mode depending on the global
 # setting.
 CPPSRC = $(AMIROOSCORECPPSRC) \
+         $(CHIBIOS)/os/various/cpp_wrappers/syscalls_cpp.cpp \
          $(APPSCPPSRC)
 
 # C sources to be compiled in ARM mode regardless of the global setting.
@@ -196,14 +200,13 @@ ASMXSRC = $(STARTUPASM) \
           $(OSALASM) \
           $(APPSASMXSRC)
 
-INCDIR = $(CHIBIOS)/os/license \
+INCDIR = $(LICINC) \
          $(STARTUPINC) \
          $(KERNINC) \
          $(PORTINC) \
          $(OSALINC) \
          $(HALINC) \
          $(PLATFORMINC) \
-         $(BOARDINC) \
          $(MODULESINC) \
          $(TESTINC) \
          $(BOOTLOADERINC) \
@@ -290,8 +293,30 @@ ULIBS +=
 # End of user defines                                                          #
 ################################################################################
 
+################################################################################
+# Start of targets section                                                     #
+#                                                                              #
 
+# all and its dependencies
+BUILDDIR = ./build
 RULESPATH = $(CHIBIOS)/os/common/startup/ARMCMx/compilers/GCC
 include $(RULESPATH)/rules.mk
 
-include ../flash.mk
+# flash
+include $(AMIROOS)/bootloader/bootloader.mk
+FLASH_MODULES = $(PROJECT)
+FLASH_FILES = $(BUILDDIR)/$(PROJECT).$(FLASHTOOL_EXT)
+
+flash: $(FLASH_FILES)
+	$(info )
+ifeq ($(FLASHTOOL),SerialBoot)
+	$(info Flashing ($(FLASHTOOL)):)
+	$(FLASHTOOL_CMD) $(FLASHTOOL_ARGS)
+else
+	$(info ERROR: unable to flash the module (SerialBoot unavailable))
+endif
+
+#                                                                              #
+# End of targets section                                                       #
+################################################################################
+
diff --git a/modules/PowerManagement_1-1/STM32F405xG.ld b/modules/PowerManagement_1-1/STM32F405xG.ld
index 14d0805..339cd14 100644
--- a/modules/PowerManagement_1-1/STM32F405xG.ld
+++ b/modules/PowerManagement_1-1/STM32F405xG.ld
@@ -1,6 +1,6 @@
 /*
 AMiRo-OS is an operating system designed for the Autonomous Mini Robot (AMiRo) platform.
-Copyright (C) 2016..2018  Thomas Schöpping et al.
+Copyright (C) 2016..2019  Thomas Schöpping et al.
 
 This program is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
diff --git a/modules/PowerManagement_1-1/alldconf.h b/modules/PowerManagement_1-1/alldconf.h
index f6b5cb6..e54b22f 100644
--- a/modules/PowerManagement_1-1/alldconf.h
+++ b/modules/PowerManagement_1-1/alldconf.h
@@ -1,6 +1,6 @@
 /*
 AMiRo-OS is an operating system designed for the Autonomous Mini Robot (AMiRo) platform.
-Copyright (C) 2016..2018  Thomas Schöpping et al.
+Copyright (C) 2016..2019  Thomas Schöpping et al.
 
 This program is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
@@ -43,6 +43,9 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  */
 #define AMIROLLD_CFG_TIME_SIZE          32
 
+// required to differentiate between various sensor rings
+#include <board.h>
+
 /**
  * @brief   Enable flag for the AT24C01BN-SH-B EEPROM.
  */
@@ -69,6 +72,23 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 #define AMIROLLD_CFG_USE_LED
 
 /**
+ * @brief   Enable flag for the PKLCS1212E4001 buzzer.
+ */
+#define AMIROLLD_CFG_USE_PKLCS1212E4001
+
+/**
+ * @brief   Enable flag for the TPS2051BDBV power switch.
+ */
+#define AMIROLLD_CFG_USE_TPS2051BDBV
+
+/**
+ * @brief   Enable flag for the TPS62113 step-down converter.
+ */
+#define AMIROLLD_CFG_USE_TPS62113
+
+#if (BOARD_SENSORRING == BOARD_PROXIMITYSENSOR) || defined(__DOXYGEN__)
+
+/**
  * @brief   Enable flag for the MPR121 touch sensor.
  */
 #define AMIROLLD_CFG_USE_MPR121
@@ -79,24 +99,39 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 #define AMIROLLD_CFG_USE_PCA9544A
 
 /**
- * @brief   Enable flag for the PKLCS1212E4001 buzzer.
+ * @brief   Enable flag for the VCNL4020 proximity sensor.
  */
-#define AMIROLLD_CFG_USE_PKLCS1212E4001
+#define AMIROLLD_CFG_USE_VCNL4020
+
+#endif /* BOARD_SENSORRING == BOARD_PROXIMITYSENSOR */
+
+#if (BOARD_SENSORRING == BOARD_DISTANCESENSOR_VL53L0X) || defined(__DOXYGEN__)
 
 /**
- * @brief   Enable flag for the TPS2051BDBV power switch.
+ * @brief   Enable flag for the PCAL6524 GPIO extender
  */
-#define AMIROLLD_CFG_USE_TPS2051BDBV
+#define AMIROLLD_CFG_USE_PCAL6524
 
 /**
- * @brief   Enable flag for the TPS62113 step-down converter.
+ * @brief   Enable flag for the AT42Q1050 touch sensor.
  */
-#define AMIROLLD_CFG_USE_TPS62113
+#define AMIROLLD_CFG_USE_AT42QT1050
+
+#endif /* BOARD_SENSORRING == BOARD_DISTANCESENSOR_VL53L0X */
+
+#if (BOARD_SENSORRING == BOARD_DISTANCESENSOR_VL53L1X) || defined(__DOXYGEN__)
 
 /**
- * @brief   Enable flag for the VCNL4020 proximity sensor.
+ * @brief   Enable flag for the PCAL6524 GPIO extender
  */
-#define AMIROLLD_CFG_USE_VCNL4020
+#define AMIROLLD_CFG_USE_PCAL6524
+
+/**
+ * @brief   Enable flag for the AT42Q1050 touch sensor.
+ */
+#define AMIROLLD_CFG_USE_AT42QT1050
+
+#endif /* BOARD_SENSORRING == BOARD_DISTANCESENSOR_VL53L1X */
 
 #endif /* _ALLDCONF_H_ */
 
diff --git a/modules/PowerManagement_1-1/aosconf.h b/modules/PowerManagement_1-1/aosconf.h
index 070a6fb..91a190d 100644
--- a/modules/PowerManagement_1-1/aosconf.h
+++ b/modules/PowerManagement_1-1/aosconf.h
@@ -1,6 +1,6 @@
 /*
 AMiRo-OS is an operating system designed for the Autonomous Mini Robot (AMiRo) platform.
-Copyright (C) 2016..2018  Thomas Schöpping et al.
+Copyright (C) 2016..2019  Thomas Schöpping et al.
 
 This program is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
@@ -17,7 +17,7 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
 
 /**
- * @file    
+ * @file
  * @brief   AMiRo-OS Configuration file for the PowerManagement v1.1 module.
  * @details Contains the application specific AMiRo-OS settings.
  *
@@ -79,6 +79,16 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 #endif
 
 /**
+ * @brief   Mask for the control thread to listen to certain IO events.
+ * @note    Any mandatory events (e.g. for SSSP) are enabled implicitely despite this configuration.
+ */
+#if !defined(OS_CFG_MAIN_LOOP_IOEVENT_MASK)
+  #define AMIROOS_CFG_MAIN_LOOP_IOEVENT_MASK    0
+#else
+  #define AMIROOS_CFG_MAIN_LOOP_IOEVENT_MASK    OS_CFG_MAIN_LOOP_IOEVENT_MASK
+#endif
+
+/**
  * @brief   Timeout value when waiting for events in the main loop in microseconds.
  * @details A value of 0 deactivates the timeout.
  */
@@ -101,7 +111,7 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  * @brief   Flag to enable SSSP.
  */
 #if !defined(OS_CFG_SSSP_ENABLE)
-  #define AMIROOS_CFG_SSSP_ENABLE               false
+  #define AMIROOS_CFG_SSSP_ENABLE               true
 #else
   #define AMIROOS_CFG_SSSP_ENABLE               OS_CFG_SSSP_ENABLE
 #endif
diff --git a/modules/PowerManagement_1-1/board.c b/modules/PowerManagement_1-1/board.c
index db3a4de..d1b1965 100644
--- a/modules/PowerManagement_1-1/board.c
+++ b/modules/PowerManagement_1-1/board.c
@@ -1,6 +1,6 @@
 /*
 AMiRo-OS is an operating system designed for the Autonomous Mini Robot (AMiRo) platform.
-Copyright (C) 2016..2018  Thomas Schöpping et al.
+Copyright (C) 2016..2019  Thomas Schöpping et al.
 
 This program is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
diff --git a/modules/PowerManagement_1-1/board.h b/modules/PowerManagement_1-1/board.h
index ba05342..6161e19 100644
--- a/modules/PowerManagement_1-1/board.h
+++ b/modules/PowerManagement_1-1/board.h
@@ -1,6 +1,6 @@
 /*
 AMiRo-OS is an operating system designed for the Autonomous Mini Robot (AMiRo) platform.
-Copyright (C) 2016..2018  Thomas Schöpping et al.
+Copyright (C) 2016..2019  Thomas Schöpping et al.
 
 This program is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
@@ -81,6 +81,19 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 #define STM32F4xx_AF_EVENTOUT           15U
 
 /*
+ * Identifiers for the several sensor rings, which can be attached to the PowerManagement v1.1 module.
+ */
+#define BOARD_NOSENSORRING              0
+#define BOARD_PROXIMITYSENSOR           1
+#define BOARD_DISTANCESENSOR_VL53L0X    2
+#define BOARD_DISTANCESENSOR_VL53L1X    3
+
+/*
+ * Configuration macro to define which type of sensor ring is attached.
+ */
+#define BOARD_SENSORRING                  BOARD_PROXIMITYSENSOR
+
+/*
  * IO pins assignments.
  */
 #define GPIOA_WKUP                      0U
diff --git a/modules/PowerManagement_1-1/chconf.h b/modules/PowerManagement_1-1/chconf.h
index 6297a3f..b59fac8 100644
--- a/modules/PowerManagement_1-1/chconf.h
+++ b/modules/PowerManagement_1-1/chconf.h
@@ -1,6 +1,6 @@
 /*
  * AMiRo-OS is an operating system designed for the Autonomous Mini Robot (AMiRo) platform.
- * Copyright (C) 2016..2018  Thomas Schöpping et al.
+ * Copyright (C) 2016..2019  Thomas Schöpping et al.
  *
  * This program is free software: you can redistribute it and/or modify
  * it under the terms of the GNU General Public License as published by
diff --git a/modules/PowerManagement_1-1/halconf.h b/modules/PowerManagement_1-1/halconf.h
index 55bf2de..ade89d8 100644
--- a/modules/PowerManagement_1-1/halconf.h
+++ b/modules/PowerManagement_1-1/halconf.h
@@ -1,6 +1,6 @@
 /*
 AMiRo-OS is an operating system designed for the Autonomous Mini Robot (AMiRo) platform.
-Copyright (C) 2016..2018  Thomas Schöpping et al.
+Copyright (C) 2016..2019  Thomas Schöpping et al.
 
 This program is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
@@ -196,13 +196,6 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 #define HAL_USE_WDG                         FALSE
 #endif
 
-/**
- * @brief   Enables the QEI subsystem.
- */
-#if !defined(HAL_USE_QEI) || defined(__DOXYGEN__)
-#define HAL_USE_QEI                         FALSE
-#endif
-
 /*===========================================================================*/
 /* PAL driver related settings.                                              */
 /*===========================================================================*/
diff --git a/modules/PowerManagement_1-1/mcuconf.h b/modules/PowerManagement_1-1/mcuconf.h
index b09231c..6f94c38 100644
--- a/modules/PowerManagement_1-1/mcuconf.h
+++ b/modules/PowerManagement_1-1/mcuconf.h
@@ -1,6 +1,6 @@
 /*
 AMiRo-OS is an operating system designed for the Autonomous Mini Robot (AMiRo) platform.
-Copyright (C) 2016..2018  Thomas Schöpping et al.
+Copyright (C) 2016..2019  Thomas Schöpping et al.
 
 This program is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
